# Templates for ci jobs
include:
   - ci/ci-templates.yml


# ---- jobs to build ubuntu, debian and fedora images ----

ubuntu:22.04:docker-build:
  variables:
    IMAGE_NAME: ubuntu22.04
  extends: .docker-build

fedora:38:docker-build:
  variables:
    IMAGE_NAME: fedora-38
  extends: .docker-build

debian:docker-build:
  variables:
    IMAGE_NAME: debian-bookworm
  extends: .docker-build

# ---- jobs to configure, build and test our software on the different images ----

  
ubuntu:configure:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/ubuntu22.04
    CONF_FILE: configs/full_debug.cmake
  extends:
    - .soft-configure

ubuntu:build:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/ubuntu22.04
  extends:
    - .soft-build
  needs: ["ubuntu:configure"]

ubuntu:test:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/ubuntu22.04
  extends:
    - .soft-test
  needs: ["ubuntu:build"]

ubuntu_lite:configure:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/ubuntu22.04
    CONF_FILE: configs/full_debug.cmake
  extends:
    - .soft-configure

ubuntu_lite:build:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/ubuntu22.04
  extends:
    - .soft-build
  needs: ["ubuntu_lite:configure"]

ubuntu_lite:test:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/ubuntu22.04
  extends:
    - .soft-test
  needs: ["ubuntu_lite:build"]

  
fedora:configure:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/fedora-38
    CONF_FILE: configs/minimal.cmake
  extends: .soft-configure

fedora:build:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/fedora-38
  extends: .soft-build
  needs: ["fedora:configure"]

fedora:test:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/fedora-38
  extends: .soft-test
  needs: ["fedora:build"]

debian:configure:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/debian-bookworm
    CONF_FILE: configs/minimal.cmake
  extends: .soft-configure

debian:build:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/debian-bookworm
  extends: .soft-build
  needs: ["debian:configure"]

debian:test:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/debian-bookworm
  extends: .soft-test
  needs: ["debian:build"]
